// Copyright 2005 "Gilles Degottex"

// This file is part of "Music"

// "Music" is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// "Music" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef _GLMonoGraph_h_
#define _GLMonoGraph_h_

#include <deque>
using namespace std;
#include "GLRTGraph.h"

#include "ANR.h"

class GLMonoGraph : public GLRTGraph, public QuantizerListener
{
	Q_OBJECT

  public:
	GLMonoGraph(QWidget* parent, const char* name);
	~GLMonoGraph(){}

	bool m_capturing_note;
	int m_name_pos;

	// note view
	struct NoteView
	{
		ANR::NoteDescription* note;
		//! name pos (for views)
		int name_pos;

		NoteView() : note(NULL) {}
	};
	deque<NoteView> m_notes_history;
	ANR::NoteDescription* m_selected_note;

 	virtual void noteStarted(int tag, int ht, double dt);
	virtual void noteFinished(int tag, int ht, double dt);
	virtual void notePlayed(int ht, double duration, double dt){}

	virtual void mouseReleaseEvent(QMouseEvent* e);

 signals:
	void selectedNoteChanged(int tag);

 public slots:
	void paintGL();
};

#endif // _GLGRAPH_

