// Copyright 2005 "Gilles Degottex"

// This file is part of "Music"

// "Music" is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// "Music" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef _GLPolyGraph_h_
#define _GLPolyGraph_h_

#include <deque>
using namespace std;
#include <qdatetime.h>
#include <qgl.h>
#include <qtimer.h>
#include <Music/Quantizer.h>
using namespace Music;
#include "GLRTGraph.h"

class GLPolyGraph : public GLRTGraph, public QuantizerListener
{
	Q_OBJECT

  public:
	GLPolyGraph(QWidget* parent, const char* name);
	~GLPolyGraph(){}

	bool m_capturing_note;

//	struct NoteView
//	{
//		int ht;
//		double duration;
//		double time;
//		int tag;
//		bool finished;
//	};
//	deque<NoteView> m_notes_history;

	virtual void noteStarted(int tag, int ht, double dt);
	virtual void noteFinished(int tag, int ht, double dt);
	virtual void notePlayed(int ht, double duration, double dt){}

 signals:
	void selectedNoteChanged(int tag);

  public slots:
	void paintGL();
};

#endif // _GLGRAPH_

