// Copyright 2005 "Gilles Degottex"

// This file is part of "midingsolo"

// "midingsolo" is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// "midingsolo" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "config.h"

#include <signal.h>
#include <iostream>
using namespace std;
#include <qapplication.h>
#include <qtextcodec.h>
#include <GL/glut.h>

#include "CustomMainForm.h"
CustomMainForm* g_main_form = NULL;

void signal_interrupt(int sig)
{
	cerr << "Interrupt" << endl;

	delete g_main_form;

	exit(sig);
}
void signal_term(int sig)
{
	cerr << "No No ! Pleeeeeease ... *argl*" << endl;
	cerr << endl;
	cerr << PACKAGE_NAME << " nastily killed with signal " << sig << endl;

	exit(sig);
}

int main(int argc, char** argv)
{
	cerr << "MidingSolo version " << PACKAGE_VERSION << " built at " << __DATE__ << " " << __TIME__ << endl;
	cerr << "ressources install path: " << PREFIX << "/" << PACKAGE_NAME << endl;

	signal(SIGINT, signal_interrupt);
	signal(SIGTERM, signal_term);

	glutInit(&argc, argv);

	QApplication a(argc, argv, true);

	QTranslator tr_midingsolo(0);
	tr_midingsolo.load(QString(PACKAGE_NAME)+"_"+QTextCodec::locale(), QString(PREFIX)+"/"+PACKAGE_NAME+"/tr");
	a.installTranslator(&tr_midingsolo);

	new ANR();

	g_main_form = new CustomMainForm();

	g_main_form->show();

	a.connect(&a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()));
	a.exec();
	
	delete g_main_form;

	return 0;
}

